#include <bits/stdc++.h>
using namespace std;
string s;
long long n, q, a, b;
int main(){
    cin >> n >> q >> s;
    for(int i = 1; i<=q; i++){
        cin >> a >> b;
        long long duz = b-a+1;
        if(duz%2==0){
            cout << duz*duz/4 << endl;
        }
        else{
           cout << duz/2*((duz+1)/2) << endl;
        }

    }
    return 0;
}